fieldinfos = {};
fieldinfos.sortByOrginal = "field";

--needs module fieldinfos
--lineType max 10/fieldinfos
function fieldinfos:load()
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {txtScroll={leftRight=true,upDown=true}};
	if moFieldinfos.values.fields ~= nil and #moFieldinfos.values.fields > 0 then
		for index=1, #moFieldinfos.values.fields do			
			if moFieldinfos.values.fields[index] ~= nil then
				local field = moFieldinfos.values.fields[index].object;
				lineTable[#lineTable+1] = {};
				local isLineTable = lineTable[#lineTable];
				isLineTable.ownValues = {field};
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].txt = tostring(moFieldinfos.values.fields[index].fillTypeName);
				isLineTable.fruitname = isLineTable.txt[1].txt;
				isLineTable.txt[1].color = moColors:getColor(moFieldinfos.values.fields[index].growthTxtColor);
				isLineTable.txt[2] = {};
				isLineTable.txt[2].txt = tostring(moFieldinfos.values.fields[index].field);
				isLineTable.field = moFieldinfos.values.fields[index].field;
				isLineTable.txt[2].txtPos = 1;
				isLineTable.txt[2].color = moColors:getColor(moFieldinfos.values.fields[index].growthTxtColor);				
				isLineTable.txt[2].clickCallback = fieldinfos.returnClickField;
				isLineTable.txt[3] = {}; --growth
				isLineTable.txt[3].txt = moFieldinfos.values.fields[index].growthTxt;
				isLineTable.growth = moFieldinfos.values.fields[index].growth;
				isLineTable.txt[3].txtPos = 1;
				isLineTable.txt[3].color = moColors:getColor(moFieldinfos.values.fields[index].growthTxtColor);
				isLineTable.txt[4] = {};
				isLineTable.txt[4].txt = moFieldinfos.values.fields[index].sprayFactor;
				isLineTable.sprayed = moFieldinfos.values.fields[index].sprayed;
				isLineTable.txt[4].txtPos = 1;
				isLineTable.txt[4].color = moColors:getColor(moModule.values.txtColor);
				if g_currentMission.missionInfo.limeRequired then			
					isLineTable.txt[#isLineTable.txt+1] = {};
					isLineTable.txt[#isLineTable.txt].txt = moFieldinfos.values.fields[index].limeFactor;
					isLineTable.lime = moFieldinfos.values.fields[index].lime;
					isLineTable.txt[#isLineTable.txt].txtPos = 1;
					isLineTable.txt[#isLineTable.txt].color = moColors:getColor(moModule.values.txtColor);
				end;
				if g_currentMission.missionInfo.plowingRequiredEnabled then
					isLineTable.txt[#isLineTable.txt+1] = {};
					isLineTable.txt[#isLineTable.txt].txt = moFieldinfos.values.fields[index].fieldPlowFactor;
					isLineTable.plowing = moFieldinfos.values.fields[index].plowing;
					isLineTable.txt[#isLineTable.txt].txtPos = 1;
					isLineTable.txt[#isLineTable.txt].color = moColors:getColor(moModule.values.txtColor);
				end;
				if g_currentMission.missionInfo.weedsEnabled then
					isLineTable.txt[#isLineTable.txt+1] = {};
					isLineTable.txt[#isLineTable.txt].txt = moFieldinfos.values.fields[index].weedFactor;
					isLineTable.weeds = moFieldinfos.values.fields[index].weeds;
					isLineTable.txt[#isLineTable.txt].txtPos = 1;
					isLineTable.txt[#isLineTable.txt].color = moColors:getColor(moModule.values.txtColor);
				end;
				isLineTable.txt[#isLineTable.txt+1] = {}; --hectar
				isLineTable.txt[#isLineTable.txt].txt = tostring(string.format("%1.2f", "".. tostring(moFieldinfos.values.fields[index].hectar)));
				isLineTable.hectar = moFieldinfos.values.fields[index].hectar;
				isLineTable.txt[#isLineTable.txt].txtPos = 1;
				isLineTable.txt[#isLineTable.txt].color = moColors:getColor(moModule.values.txtColor);
			end;
		end;
	end;
	function comp(w1,w2)		
		if moFieldinfos.values.sortBy > 2 then
			if w1[fieldinfos.sortByOrginal:lower()] > w2[fieldinfos.sortByOrginal:lower()] then
				return true;
			end;
		else
			if w1[fieldinfos.sortByOrginal:lower()] < w2[fieldinfos.sortByOrginal:lower()] then
				return true;
			end;
		end;
	end;
	table.sort(lineTable, comp);
	function setFirstLine()
		table.insert(lineTable, 1, {});		
		local isLineTable = lineTable[1];
		isLineTable.lineClickHelp = true;
		isLineTable.lineClickHelpCallback = fieldinfos.returnLineHelpIconClick;
		isLineTable.helpTxt = "Click Field (MapHotSpot) or ...\nClick Sort By ... for SortType\nOnly Manual Update (because of performance)";
		isLineTable.txt = {};
		isLineTable.txt[1] = {color=moColors:getColor(moModule.values.txtTitleColor), txtPos=1, txt="Fieldinfos (".. tostring(#moFieldinfos.values.fields).. ")", bold=true};
		table.insert(lineTable, 2, {});
		isLineTable = lineTable[2];		
		isLineTable.txt = {};
		local color = moColors.intern["green"];
		if MultiOverlayV3.timers["updateFieldinfos"] ~= nil then color = moColors.intern["red"];end;
		isLineTable.txt[1] = {clickCallback=fieldinfos.returnLineUpdateByClick, color=color, txtPos=0, txt="Manual Update", bold=true};
		isLineTable.txt[1].settingsButtonL = {"buttonLeft", color, fieldinfos.returnLineUpdateByClick};
		table.insert(lineTable, 3, {});
		isLineTable = lineTable[3];		
		isLineTable.txt = {};
		isLineTable.txt[1] = {clickCallback=fieldinfos.returnLineSortByClick, color=moColors:getColor(moModule.values.txtTitleColor), txtPos=0, txt="Sort By ".. tostring(moFieldinfos.values.sortByName[moFieldinfos.values.sortBy]), bold=true};
		isLineTable.txt[1].settingsButtonL = {"buttonLeft", moColors.intern["green"], fieldinfos.returnLineSortByClick};
		table.insert(lineTable, 4, {});
		isLineTable = lineTable[4];		
		isLineTable.txt = {};
		for sortByName=1, #moFieldinfos.values.sortByName do		
			local sortTxt = tostring(moFieldinfos.values.sortByName[sortByName]);
			local isSelect = sortByName == moFieldinfos.values.sortBy;
			if isSelect then sortTxt = ">".. sortTxt.. "<";end;
			isLineTable.txt[sortByName] = {color=moColors:getColor(moModule.values.txtTitleColor), txtPos=1, txt=sortTxt, bold=true};		
		end;		
	end;
	setFirstLine();	
	fieldinfos.output = lineTable;
end;

function fieldinfos.returnClickField(...)
	if ... ~= nil then		
		local args = ...;
		if args ~= nil and args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then			
			local field = fieldinfos.output[args.line].ownValues[1];
			local x = field.posX;
			local z = field.posZ;
			if x ~= nil and x ~= 0 then
				moSetGetOverlays:mapHotSpot(nil, x, z);
			end;		
		end;		
	end;
end;

function fieldinfos.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(fieldinfos.output[args.line].helpTxt);
		end;
	end;
end;

function fieldinfos.returnLineSortByClick(...)
	if ... ~= nil then		
		local args = ...;
		if g_currentMission.missionInfo.limeRequired ~= moFieldinfos.values.status.limeEnabled or
		g_currentMission.missionInfo.plowingRequiredEnabled ~= moFieldinfos.values.status.plowingEnabled or
		g_currentMission.missionInfo.weedsEnabled ~= moFieldinfos.values.status.weedsEnabled or
		g_currentMission.missionInfo.isPlantWitheringEnabled ~= moFieldinfos.values.status.witheringEnabled then
		fieldinfos.returnLineUpdateByClick(args);end;
		if moFieldinfos.values.sortBy+1 > #moFieldinfos.values.sortByName then moFieldinfos.values.sortBy = 1;else moFieldinfos.values.sortBy = moFieldinfos.values.sortBy+1;end;
		fieldinfos.sortByOrginal = moFieldinfos.values.sortByOrginalName[moFieldinfos.values.sortBy];
	end;
end;

function fieldinfos.returnLineUpdateByClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if MultiOverlayV3.timers["updateFieldinfos"] ~= nil then g_currentMission:showBlinkingWarning("Wait 5 sec -Cooldown Active-", 2000);return;end;
		moSetGetExtras:addTimer( {delay=5, name="updateFieldinfos", repeatable=1, ms=true, action=nil} );
		moFieldinfosConfig:defaultValues();
		moFieldinfos:load(true);
	end;
end;

function fieldinfos.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;		
		if g_currentMission.missionInfo.limeRequired ~= moFieldinfos.values.status.limeEnabled or
		g_currentMission.missionInfo.plowingRequiredEnabled ~= moFieldinfos.values.status.plowingEnabled or
		g_currentMission.missionInfo.weedsEnabled ~= moFieldinfos.values.status.weedsEnabled or
		g_currentMission.missionInfo.isPlantWitheringEnabled ~= moFieldinfos.values.status.witheringEnabled then
		fieldinfos.returnLineUpdateByClick(args);end;
		fieldinfos:load();
		return fieldinfos.output;
	end;
end;

function fieldinfos:reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--fieldinfos:load();
end;

function fieldinfos:generateCmd()
	local _, errorTable = 0, {};
	local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
	newCmdTable.cmdTable[1] = {
		cmdName = "fieldinfos";
		displayName = "Fieldinfos";		
		multiple = false;
		sortBy = "Module by Moh";
		infoTxt = "Zeigt alle Felderinfos an";
		helpTxt = "Fieldinfos List";
		click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
		lineTyp = 10;
		typ = "output";
		action = fieldinfos.giveOutputTable; --a function
		ownValues = {}; 
	};	
	_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
	local errorPrint = false;
	if errorPrint and #errorTable > 0 then
		for a=1, #errorTable do
			print("! ERROR ! MultiOverlayV3 Hud -->cmd generate fieldinfos Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
		end;
	end;
end;